require("Helpers")

AddToCounterUIComponent = AddToCounterUIComponent or {}

function AddToCounterUIComponent:construct()
	self.counterComponentPath = GetProp(self, "CounterComponent Path", "string")
end

function AddToCounterUIComponent:OnPropertyChanged(prop)
	if prop:GetName() == "CounterComponent Path" then
		self.counterComponentPath = GetProp(self, "CounterComponent Path", "string")
	end
end

function AddToCounterUIComponent:OnEnable()
	self:Increment()
end

function AddToCounterUIComponent:Increment()
	local counterComponent = GameCore.FindEntity(self.counterComponentPath)
	if not counterComponent then
		self:LogE("Could not find CounterComponent at " .. self.counterComponentPath)
		return
	end

	local componentId = counterComponent:GetId()
	if not componentId == "CounterComponent" then
		self:LogE("Not a CounterComponent at " .. self.counterComponentPath)
		return
	end

	if not counterComponent:IsEnabled() then
		self:LogD("CounterComponent is disabled. Ignoring.")
		return
	end

	counterComponent:Add()
end