require("Helpers")

BrickUIProxyComponent = BrickUIProxyComponent or {}

function BrickUIProxyComponent:construct()
	self.brickUIProxyComponentPath = self:CreateProperty("BrickUI Component Path", "string", "")
end

function BrickUIProxyComponent:OnEnable()
	self:EnableComponent()
end

function BrickUIProxyComponent:OnDisable()
	self:DisableComponent()
end

function BrickUIProxyComponent:EnableComponent()
	if IsNilOrEmpty(self.brickUIProxyComponentPath:GetValue()) then
		return
	end

	local component = UserInterfaceManager:FindComponent(self.brickUIProxyComponentPath:GetValue());
	if not component then
		self:LogE("Could not find brickUI component at " .. self.brickUIProxyComponentPath:GetValue() .. "!")
		return
	end

	SetProp(component, "enabled", "bool", true)
end

function BrickUIProxyComponent:DisableComponent()
	if IsNilOrEmpty(self.brickUIProxyComponentPath:GetValue()) then
		return
	end

	local component = UserInterfaceManager:FindComponent(self.brickUIProxyComponentPath:GetValue());
	if not component then
		self:LogE("Could not find brickUI component at " .. self.brickUIProxyComponentPath:GetValue() .. "!")
		return
	end

	SetProp(component, "enabled", "bool", false)
end