require("Helpers")

ButtonTemplateUIComponent = ButtonTemplateUIComponent or {}

function ButtonTemplateUIComponent:construct()
	self.listenerAdded = false
end

function ButtonTemplateUIComponent:OnPropertyChanged(prop)
end

function ButtonTemplateUIComponent:OnEnable()
	self:AddListener()
end

function ButtonTemplateUIComponent:OnPressed()
	self:LogD("Pressed!")
end

function ButtonTemplateUIComponent:AddListener()
	if self.listenerAdded then
		return
	end
	
	-- Set button event
	local button = self:GetComponentOfType("^", "ComponentButton")
	if not button then
		self:LogE("Could not find ComponentButton!")
		return
	end

	button:SetEventHandler_OnButtonPressed(nil, ButtonTemplateUIComponent_OnButtonPressed)
	self.listenerAdded = true
end

-- Only support for global methods at the moment, so be sure to update this name to 
-- match the script and not cause a conflict with other global methods
function ButtonTemplateUIComponent_OnButtonPressed(component)
	-- find the ButtonTemplateUIComponent associated with this ComponentButton
	local listeningComponent = component:FindEntity("ButtonTemplateUIComponent")
	if not listeningComponent or not GetProp(listeningComponent, "enabled", "bool") then
		return
	end

	listeningComponent:OnPressed()
end
