require("Helpers")

DeltaTimeActivatorComponent = DeltaTimeActivatorComponent or {}

local GAMETASKFRUITNINJA_ID = "GameTaskFruitNinja"
local UTILITIES_ID = "Utilities"
local DELTATIMECOMPONENT_ID = "DeltaTimeComponent"

function DeltaTimeActivatorComponent:construct()

end

function DeltaTimeActivatorComponent:OnEnable()
	self:Activate()
end

function DeltaTimeActivatorComponent:OnDisable()
	self:Deactivate()
end

function DeltaTimeActivatorComponent:Activate()
	local gameTaskFruitNinja = GameCore.FindLiveTask(GAMETASKFRUITNINJA_ID)
	if not gameTaskFruitNinja then
		self:LogE("Could not find " .. GAMETASKFRUITNINJA_ID)
		return
	end
	
	local utilities = gameTaskFruitNinja:FindEntity(UTILITIES_ID)
	if not utilities then
		self:LogE("Could not find " .. UTILITIES_ID .. " in " .. GAMETASKFRUITNINJA_ID)
		return
	end
	
	local deltaTimeComponent = utilities:FindEntity(DELTATIMECOMPONENT_ID)
	if not deltaTimeComponent then
		self:LogE("Could not find " .. DELTATIMECOMPONENT_ID .. " in " .. UTILITIES_ID)
		return
	end
	
	deltaTimeComponent:Enable()
end

function DeltaTimeActivatorComponent:Deactivate()
	local gameTaskFruitNinja = GameCore.FindLiveTask(GAMETASKFRUITNINJA_ID)
	if not gameTaskFruitNinja then
		self:LogE("Could not find " .. GAMETASKFRUITNINJA_ID)
		return
	end
	
	local utilities = gameTaskFruitNinja:FindEntity(UTILITIES_ID)
	if not utilities then
		self:LogE("Could not find " .. UTILITIES_ID .. " in " .. GAMETASKFRUITNINJA_ID)
		return
	end
	
	local deltaTimeComponent = utilities:FindEntity(DELTATIMECOMPONENT_ID)
	if not deltaTimeComponent then
		self:LogE("Could not find " .. DELTATIMECOMPONENT_ID .. " in " .. UTILITIES_ID)
		return
	end
	
	deltaTimeComponent:Disable()
end