require("Helpers")

DisableChildrenOnDisableComponent = DisableChildrenOnDisableComponent or {}

function DisableChildrenOnDisableComponent:OnDisable()
	local actor = self:GetParentActor()
	if not actor then
		self:LogE("Could not find actor!")
		return
	end
	
	local children = actor:GetChildren()
	if not children then
		self:LogE("Unable to get children!")
		return
	end
	
	-- disable all actors
	local count = #children
	for i = 1, count do
		local child = children[i]
		
		local childType = child:GetType()
		
		if childType == "Actor" or childType == "ActorExtended" then
			SetProp(child, "enabled", "bool", false)
		end
	end	
end