require("Helpers")

EnableComponentOnScoreGoalComponent = EnableComponentOnScoreGoalComponent or {}

function EnableComponentOnScoreGoalComponent:construct()
	self.componentPath = self:CreateProperty("Component Path", "string", "")
	self.scoreGoal = self:CreateProperty("Score Goal", "int", 30)
	self.playerNumber = self:CreateProperty("Player Number", "int", 0)

	self.prevScore = 0
end

function EnableComponentOnScoreGoalComponent:OnEnable()
	self.prevScore = 0
end

function EnableComponentOnScoreGoalComponent:Update(dt)
	local currentScore = ScoreControl.GetCurrentScore(self.playerNumber:GetValue())

	if currentScore >= self.scoreGoal:GetValue() and self.prevScore < self.scoreGoal:GetValue() then
		self:EnableComponent()
	end

	self.prevScore = currentScore
end

function EnableComponentOnScoreGoalComponent:EnableComponent()
	if IsNilOrEmpty(self.componentPath:GetValue()) then
		return
	end

	local component = self:FindEntity(self.componentPath:GetValue())
	if not component then
		self:LogE("Could not find component at '" .. self.componentPath:GetValue() .. "'!")
		return
	end

	component:Enable()
end