require("Helpers")

EnableOnSkippedDialogueUIComponent = EnableOnSkippedDialogueUIComponent or {}

function EnableOnSkippedDialogueUIComponent:construct()
	self.dialogueName = GetProp(self, "Dialogue Name", "string")
	self.path = GetProp(self, "Path", "string")
end

function EnableOnSkippedDialogueUIComponent:OnPropertyChanged(prop)
	local name = prop:GetName()
	if name == "Dialogue Name" then
		self.dialogueName = GetProp(self, "Dialogue Name", "string")
	elseif name == "Path" then
		self.path = GetProp(self, "Path", "string")
	end
end

function EnableOnSkippedDialogueUIComponent:OnEnable()
	self:Go()
end

function EnableOnSkippedDialogueUIComponent:Go()
	self:LogD("Going...")
	if not DialogueManager.HasUserSeenDialog(self.dialogueName) then
		return
	end

	self:EnableComponent()
end

function EnableOnSkippedDialogueUIComponent:EnableComponent()
	self:LogD("Enabling...")
	if IsNilOrEmpty(self.path) then
		return
	end

	local component = self:FindEntity(self.path)
	if not component then
		self:LogE("Could not find " .. self.path)
		return
	end

	SetProp(component, "enabled", "bool", true)
end