require("Helpers")

EventCharacterSheetComponent = EventCharacterSheetComponent or {}

function EventCharacterSheetComponent:construct()
	self.positiveCueName = self:CreateProperty("Positive Cue", "string", "")
	self.negativeCueName = self:CreateProperty("Negative Cue", "string", "")
	self.greetingCueName = self:CreateProperty("Greeting Cue", "string", "")
	self.positiveCue = nil
	self.negativeCue = nil
	self.greetingCue = nil
end

function EventCharacterSheetComponent:OnPropertyChanged(prop)
	if prop == self.positiveCueName then
		if IsNilOrEmpty(self.positiveCueName:GetValue()) then
			self.positiveCue = nil
		else
			self.positiveCue = GetGlobalSoundCue(self.positiveCueName:GetValue())
			if not self.positiveCue then
				self:LogE("Positive Cue is nil!")
			end
		end
	elseif prop == self.negativeCueName then
		if IsNilOrEmpty(self.negativeCueName:GetValue()) then
			self.negativeCue = nil
		else
			self.negativeCue = GetGlobalSoundCue(self.negativeCueName:GetValue())
			if not self.negativeCue then
				self:LogE("Negative Cue is nil!")
			end
		end
	elseif prop == self.greetingCueName then
		if IsNilOrEmpty(self.greetingCueName:GetValue()) then
			self.greetingCue = nil
		else
			self.greetingCue = GetGlobalSoundCue(self.greetingCueName:GetValue())
			if not self.greetingCue then
				self:LogE("Greeting Cue is nil!")
			end
		end
	end
end

function EventCharacterSheetComponent:FirstUpdate()
	if IsNilOrEmpty(self.positiveCueName:GetValue()) then
		self.positiveCue = nil
	else
		self.positiveCue = GetGlobalSoundCue(self.positiveCueName:GetValue())
		if not self.positiveCue then
			self:LogE("Positive Cue is nil!")
		end
	end

	if IsNilOrEmpty(self.negativeCueName:GetValue()) then
		self.negativeCue = nil
	else
		self.negativeCue = GetGlobalSoundCue(self.negativeCueName:GetValue())
		if not self.negativeCue then
			self:LogE("Negative Cue is nil!")
		end
	end

	if IsNilOrEmpty(self.greetingCueName:GetValue()) then
		self.greetingCue = nil
	else
		self.greetingCue = GetGlobalSoundCue(self.greetingCueName:GetValue())
		if not self.greetingCue then
			self:LogE("Greeting Cue is nil!")
		end
	end
end

function EventCharacterSheetComponent:OnGreet()
	if not self.greetingCue then
		return
	end
	
	self.greetingCue:Play()
end

function EventCharacterSheetComponent:OnModApplied(category)
	if IsNilOrEmpty(category) then
		self:LogE("Category is empty!")
		return
	end
	
	if category == "Positive" then
		if self.positiveCue then
			self.positiveCue:Play()
		end
	elseif category == "Negative" then
		if self.negativeCue then
			self.negativeCue:Play()
		end	
	else
		self:LogE("Unhandled category " .. category)
	end
end