require("Helpers")

ExemptSwitchedUserFromFTFTutorialComponent = ExemptSwitchedUserFromFTFTutorialComponent or {}

local CLOUDOBJECT_ID = "Tutorial"
local TUTORIAL_ID = "FTFTutorial"

local EXEMPTION_KEY = "exemption"
local EXEMPTION_REASON_KEY = "reason"

local EXEMPTION_REASON_VALUE = "switched_user"

function ExemptSwitchedUserFromFTFTutorialComponent:construct()
end

function ExemptSwitchedUserFromFTFTutorialComponent:OnPropertyChanged(prop)
end

function ExemptSwitchedUserFromFTFTutorialComponent:OnEnable()
end

function ExemptSwitchedUserFromFTFTutorialComponent:OnUserChanged(prevUser, newUser)
	-- check cloud data
	local tutorialCloudObj = CloudService.GetUserObject(newUser, CLOUDOBJECT_ID)
	if not tutorialCloudObj then
		self:LogE("Cloud object '" .. CLOUDOBJECT_ID .. "' is nil!")
		return
	end

	-- if there is no data for the tutorial, assume it is too late
	local tutorialObj = tutorialCloudObj:GetValueAtPath(TUTORIAL_ID)
	if tutorialObj and tutorialObj:IsObject() then
		self:LogD("Has '" .. TUTORIAL_ID .. "'. ")
		return
	end

	self:LogD("Setting exemption for '" .. TUTORIAL_ID .. "'. Reason: " .. EXEMPTION_REASON_VALUE)
	local exemptionValue = tutorialCloudObj:GetValueAtPath(TUTORIAL_ID .. "." .. EXEMPTION_KEY .. "." .. EXEMPTION_REASON_KEY)
	tutorialCloudObj:ConditionalSetNewer(exemptionValue, EXEMPTION_REASON_VALUE)
	tutorialCloudObj:SaveLocalChanges()
end