require("Helpers")

DismissGameOverButtonUIComponent = DismissGameOverButtonUIComponent or {}

function DismissGameOverButtonUIComponent:construct()
	self.listenerAdded = false
end

function DismissGameOverButtonUIComponent:OnPropertyChanged(prop)
end

function DismissGameOverButtonUIComponent:OnEnable()
	self:AddListener()
end

function DismissGameOverButtonUIComponent:OnPressed()
	local gameOverComponent = GameCore.FindEntityOfType("GameOverComponent")
	if not gameOverComponent then
		self:LogE("Could not find GameOverComponent!")
		return
	end
	
	gameOverComponent:Dismiss()
end

function DismissGameOverButtonUIComponent:AddListener()
	if self.listenerAdded then
		return
	end
	
	-- Set button event
	local button = self:GetComponentOfType("^", "ComponentButton")
	if not button then
		self:LogE("Could not find ComponentButton!")
		return
	end

	button:SetEventHandler_OnButtonPressed(nil, DismissGameOverButtonUIComponent_OnButtonPressed)
	self.listenerAdded = true
end

-- Only support for global methods at the moment, so be sure to update this name to 
-- match the script and not cause a conflict with other global methods
function DismissGameOverButtonUIComponent_OnButtonPressed(component)
	-- find the DismissGameOverButtonUIComponent associated with this ComponentButton
	local listeningComponent = component:FindEntity("DismissGameOverButtonUIComponent")
	if not listeningComponent or not GetProp(listeningComponent, "enabled", "bool") then
		return
	end

	listeningComponent:OnPressed()
end
