require("Helpers")

StartModeButtonUIComponent = StartModeButtonUIComponent or {}

function StartModeButtonUIComponent:construct()
	self.listenerAdded = false
end

function StartModeButtonUIComponent:OnPropertyChanged(prop)
end

function StartModeButtonUIComponent:OnEnable()
	self:AddListener()
end

function StartModeButtonUIComponent:OnPressed()
	local startModeComponent = GameCore.FindEntityOfType("StartModeComponent")
	if not startModeComponent then
		self:LogE("Could not find StartModeComponent!")
		return
	end
	
	startModeComponent:Start()
end

function StartModeButtonUIComponent:AddListener()
	if self.listenerAdded then
		return
	end
	
	-- Set button event
	local button = self:GetComponentOfType("^", "ComponentButton")
	if not button then
		self:LogE("Could not find ComponentButton!")
		return
	end

	button:SetEventHandler_OnButtonPressed(nil, StartModeButtonUIComponent_OnButtonPressed)
	self.listenerAdded = true
end

-- Only support for global methods at the moment, so be sure to update this name to 
-- match the script and not cause a conflict with other global methods
function StartModeButtonUIComponent_OnButtonPressed(component)
	-- find the StartModeButtonUIComponent associated with this ComponentButton
	local listeningComponent = component:FindEntity("StartModeButtonUIComponent")
	if not listeningComponent or not GetProp(listeningComponent, "enabled", "bool") then
		return
	end

	listeningComponent:OnPressed()
end
