require("Helpers")

OnGameOverComponent = OnGameOverComponent or {}

function OnGameOverComponent:construct()
	self.disappearEmitterPrefabPath = self:CreateProperty("Disappear Emitter Prefab", "string", "")
end

function OnGameOverComponent:OnEnable()
	self:Activate()
end

function OnGameOverComponent:Activate()
	-- if there is an emitter prefab then play it on the bombs
	-- make sure that it is selfDestroyable
	if not IsNilOrEmpty(self.disappearEmitterPrefabPath:GetValue()) then

		local emitter = GameCore.FindEntity(self.disappearEmitterPrefabPath:GetValue())

		if emitter then
			-- find all BombContainers
			local fruitNinjaTask = GameCore.FindLiveTask("GameTaskFruitNinja")
			if fruitNinjaTask then
				local bombRoot = GameCore.FindEntity("$ROOT_TasksLive$.GameTaskFruitNinja.GameEntities.BombRoot")
				if bombRoot then
					local children = bombRoot:GetChildren()

					for i = 1, #children do
						self:LogD("Doing...")
						local clone = emitter:Clone()
						fruitNinjaTask:AddChild(clone)
						local bombPos = GetProp(children[i], "position", "vector3")
						SetProp(clone, "position", "vector3", bombPos)
						SetProp(clone, "enabled", "bool", true)
					end
				end
			end
		end
	end

	-- find a BombClearerComponent
	local bombClearer = self:GetSiblingComponentOfType("BombClearerComponent")
	if not bombClearer then
		self:LogE("No sibling BombClearerComponent!")
		return
	end

	bombClearer:Disable()
end