require("Helpers")

ProgressTutorialOnEnableComponent = ProgressTutorialOnEnableComponent or {}

local TUTORIAL_TASK_ID = "GameTask_Tutorial"

function ProgressTutorialOnEnableComponent:construct()
	self.tutorialName = self:CreateProperty("Tutorial Name", "string", "")
end

function ProgressTutorialOnEnableComponent:OnEnable()
	if IsNilOrEmpty(self.tutorialName:GetValue()) then
		self:LogE("Tutorial Name is empty!")
		return
	end
	
	local task = GameCore.FindLiveTask(TUTORIAL_TASK_ID)
	if not task then
		self:LogE("Could not find " .. TUTORIAL_TASK_ID .. "!")
		return	
	end
	
	local onGameStart = task:FindEntity("OnGameStart")
	if not onGameStart then
		self:LogE("Could not find OnGameStart!")
		return	
	end
	
	local actor = onGameStart:FindEntity(self.tutorialName:GetValue())
	if not actor then
		self:LogE("Could not find " .. self.tutorialName:GetValue() .. "!")
		return	
	end
	
	if actor:GetType() ~= "Actor" and  actor:GetType() ~= "ActorExtended" then
		self:LogE(self.tutorialName:GetValue() .. " is not an actor!")
		return
	end
	
	local tutorialComponent = actor:FindEntity("TutorialComponent")
	if not tutorialComponent then
		self:LogE("Could not find 'TutorialComponent' in " .. self.tutorialName:GetValue() .. "!")
		return	
	end
	
	tutorialComponent:Next()
end