-- Contains some 'helpful' methods
require("Helpers")

-- Make sure the script table name shares the same name as the script
-- SampleComponent.lua ==> SampleComponent table name

SampleComponent = SampleComponent or {}

-- all table methods should have the table name 

-- called when the script become active, fill in your properties here
function SampleComponent:construct()
	self.elFlag = GetProp(self, "El Flag", "bool")
	self.elString = GetProp(self, "El String", "string")
end

-- when a property changes, we need to mirror them with our self properties
function SampleComponent:OnPropertyChanged(name, propertyType)
	if name == "El Flag" then
		self.elFlag = GetProp(self, "El Flag", "bool")
		self:LogOut()
	elseif name == "El String" then
		self.elString = GetProp(self, "El String", "string")
		self:LogOut()
	end
end

-- When the script is first active in the screen
function SampleComponent:FirstUpdate()

end

-- When the script becomes enabled if previously disabled
function SampleComponent:OnEnable()
	self:LogOut()
end

-- When the script becomes disabled if previously enabled
function SampleComponent:OnDisable()

end

-- Called every frame when enabled
function SampleComponent:Update(dt)
	
end

function SampleComponent:LogOut()
	-- Log out the sample text if checked
	if not self.elFlag then
		return
	end
	
	-- using a method from Helpers.lua
	if IsNilOrEmpty(self.elString) then
		return
	end
	
	self:LogD("Logging: " .. self.elString)
end