-- Contains some 'helpful' methods
require("Helpers")

-- Make sure the script table name shares the same name as the script
-- SampleUIComponent.lua ==> SampleUIComponent table name

SampleUIComponent = SampleUIComponent or {}

-- all table methods should have the table name 

-- called when the script become active, fill in your properties here
function SampleUIComponent:construct()
	self.elFlag = GetProp(self, "El Flag", "bool")
	self.elString = GetProp(self, "El String", "string")
end

-- when a property changes, we need to mirror them with our self properties
function SampleUIComponent:OnPropertyChanged(prop)
	local name = prop:GetName()
	if name == "El Flag" then
		self.elFlag = GetProp(self, "El Flag", "bool")
		self:LogOut()
	elseif name == "El String" then
		self.elString = GetProp(self, "El String", "string")
		self:LogOut()
	end
end

-- When the script is first active in the screen
function SampleUIComponent:FirstUpdate()

end

-- When the script becomes enabled if previously disabled
function SampleUIComponent:OnEnable()
	self:LogOut()
end

-- When the script becomes disabled if previously enabled
function SampleUIComponent:OnDisable()

end

-- Called every frame when enabled
function SampleUIComponent:Update(dt)
	
end

function SampleUIComponent:LogOut()
	-- Log out the sample text if checked
	if not self.elFlag then
		return
	end
	
	-- using a method from Helpers.lua
	if IsNilOrEmpty(self.elString) then
		return
	end
	
	self:LogD("Logging: " .. self.elString)
end