require("Helpers")

SetAngleOnSlice = SetAngleOnSlice or {}

local SLICE_PREPARE_ROTATION = Vector3(0,0,0)

function SetAngleOnSlice:construct()
end

function SetAngleOnSlice:OnSlice(bladeDir)
	self:Rotate(bladeDir)
end

function SetAngleOnSlice:OnBreak(bladeDir)
	self:Rotate(bladeDir)
end

function SetAngleOnSlice:Rotate(bladeDir)
	local magSqr = bladeDir:MagnitudeSqr()
	if magSqr == 0.0 or bladeDir.z ~= 0.0 then
		self:LogE("Invalid blade dir!")
		return
	end
	
	local dir = Vector2(bladeDir.x, bladeDir.y):Normalised()

	local angle = dir:ToAngleDeg()
	local euler = Vector3(SLICE_PREPARE_ROTATION.x, SLICE_PREPARE_ROTATION.y, SLICE_PREPARE_ROTATION.z)

	euler.z = -angle + euler.z
	self:SetRotationFromEuler(euler)
end